﻿
namespace TreeViewLoadonDemandRIAServices.Web
{
	using System;
	using System.Collections.Generic;
	using System.ComponentModel;
	using System.ComponentModel.DataAnnotations;
	using System.Data;
	using System.Linq;
	using System.ServiceModel.DomainServices.EntityFramework;
	using System.ServiceModel.DomainServices.Hosting;
	using System.ServiceModel.DomainServices.Server;
	using System.Collections.ObjectModel;


	// Implements application logic using the SelfReferencingDatabaseEntities context.
	// TODO: Add your application logic to these methods or in additional methods.
	// TODO: Wire up authentication (Windows/ASP.NET Forms) and uncomment the following to disable anonymous access
	// Also consider adding roles to restrict access as appropriate.
	// [RequiresAuthentication]
	[EnableClientAccess()]
	public class MyDomainService : LinqToEntitiesDomainService<MyDatabaseEntities>
	{

		// TODO:
		// Consider constraining the results of your query method.  If you need additional input you can
		// add parameters to this method or create additional query methods with different names.
		// To support paging you will need to add ordering to the 'MyDataTables' query.
		public IQueryable<MyDataTable> GetMyDataTables()
		{
			return this.ObjectContext.MyDataTables.Include("Children").Where(p=>p.ParentID == null);
		}

		public IQueryable<MyDataTable> GetChildrenByParentID(int? parentID)
		{
			return this.ObjectContext.MyDataTables.Include("Children").Where(p => p.ParentID == parentID);
		}
		
		public void InsertMyDataTable(MyDataTable myDataTable)
		{
			if ((myDataTable.EntityState != EntityState.Detached))
			{
				this.ObjectContext.ObjectStateManager.ChangeObjectState(myDataTable, EntityState.Added);
			}
			else
			{
				this.ObjectContext.MyDataTables.AddObject(myDataTable);
			}
		}

		public void UpdateMyDataTable(MyDataTable currentMyDataTable)
		{
			this.ObjectContext.MyDataTables.AttachAsModified(currentMyDataTable, this.ChangeSet.GetOriginal(currentMyDataTable));
		}

		public void DeleteMyDataTable(MyDataTable myDataTable)
		{
			if ((myDataTable.EntityState == EntityState.Detached))
			{
				this.ObjectContext.MyDataTables.Attach(myDataTable);
			}
			this.ObjectContext.MyDataTables.DeleteObject(myDataTable);
		}
	}
}


