﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Navigation;
using TreeViewLoadonDemandRIAServices.Web;
using Telerik.Windows.Controls;
using System.Collections.ObjectModel;
using System.ServiceModel.DomainServices.Client;
using System.Collections;

namespace TreeViewLoadonDemandRIAServices.Views
{
	public partial class TreeViewPage : Page
	{
		MyDomainContext context = new MyDomainContext();
		public TreeViewPage()
		{
			InitializeComponent();
			this.Loaded += new RoutedEventHandler(TreeViewPage_Loaded);
		}

		void TreeViewPage_Loaded(object sender, RoutedEventArgs e)
		{
			var rootEntities = context.Load(context.GetMyDataTablesQuery());
			this.myTreeView.ItemsSource = rootEntities.Entities;
		}

		// Executes when the user navigates to this page.
		protected override void OnNavigatedTo(NavigationEventArgs e)
		{
		}

		private void myTreeView_LoadOnDemand(object sender, Telerik.Windows.RadRoutedEventArgs e)
		{
			// get the clicked Item
			RadTreeViewItem clickedItem = e.OriginalSource as RadTreeViewItem;
			MyDataTable dataItem = clickedItem.Item as MyDataTable;
			var childrenLoad = context.Load(context.GetChildrenByParentIDQuery(dataItem.ID));
			childrenLoad.Completed += (s, args) => clickedItem.IsLoadOnDemandEnabled = childrenLoad.Entities.Any();
		}

		private void myTreeView_ItemPrepared(object sender, RadTreeViewItemPreparedEventArgs e)
		{
			var treeViewItem = e.PreparedItem;
			var dataItem = treeViewItem.Item as MyDataTable;
			if (dataItem.ChildrenCount <= 0)
			{
				treeViewItem.IsLoadOnDemandEnabled = false;
			}
		}

	}
}
